#ifndef FILE_OP
#define FILE_OP

#include <stdio.h>
#include "bonnie.h"
#include "bon_time.h"

class CFileOp
{
public:
  CFileOp();
  void set_size(int size);
  int open(CPCCHAR basename, bool create);
  ~CFileOp();
  int write_block_putc();
  int write_block(CPCVOID buf);
  int read_block_getc(char *buf);
  int read_block(PVOID buf);
  int seek(int offset, int whence);
  int doseek(long where, bool update);
  void close();
  int reopen(bool create);
private:
  int m_open(CPCCHAR basename, int ind, bool create);
  int m_max_file_size, m_chunks_per_file, m_total_chunks;
  int m_last_file_chunks;
  int m_cur_pos;
  int m_file_ind;
  FILE **m_stream;
  int *m_fd;
  int m_num_files;
  bool m_isopen;
  char *m_name;
};

class COpenTest
{
public:
  COpenTest();
  ~COpenTest();

  int create(CPCCHAR dirname, BonTimer &timer, int num, bool do_random);
  int delete_random(BonTimer &timer);
  int delete_sequential(BonTimer &timer);
  int stat_random(BonTimer &timer);
  int stat_sequential(BonTimer &timer);

private:
  void make_names(int num, bool do_random);

  int m_number;
  char *m_used;
  char *m_dirname;
  char *m_file_name_buf;
  char **m_file_names;
};

#endif
